<template>
  <div class="projects">
    <Grid
      :config="config"
      :data="projects"
    >
      <template #GridFooter="{activeData}">
        <ProjectsSummary :activeData="activeData" />
      </template>
    </Grid>
    <Alert
      v-if="alert.isVisible"
      @onClose="handleCloseAlert"
      :popup="true"
      :alertType="alert.type"
    >
    <span v-html="alert.content"></span>

    </Alert>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import Grid from '@/components/grid/Grid.vue';
import GridConfig, { GridRow } from '@/components/grid/GridConfig';
import { namespace } from 'vuex-class';
import ProjectsSummary from '@/components/pages/projects/Summary.vue';
import { Alert } from '@/components/atoms';
import { Alert as AlertType } from '@/types';

const projects = namespace('projects');

@Component({
  components: {
    Grid,
    ProjectsSummary,
    Alert,
  },
})
export default class ProjectsPage extends Vue {
  private alert: AlertType = {
    isVisible: false,
    content: '',
    type: '',
  }

  get config() {
    return new GridConfig(
      'projects',
      [
        {
          key: 'id',
          label: 'ID',
        },
        {
          key: 'name',
          label: 'Name',
        },
        {
          key: 'dateDue',
          label: 'Date due',
          formatType: 'date',
        },
        {
          key: 'sourceLanguage',
          label: 'Source language',
        },
        {
          key: 'targetLanguages',
          label: 'Target languages',
          formatType: 'array',
        },
        {
          key: 'status',
          label: 'Status',
        },
      ],
      {
        title: 'Projects',
        filters: [
          {
            name: 'name',
            label: 'Name',
            operator: '=',
            value: '',
          },
          {
            name: 'status',
            label: 'Status',
            operator: '=',
            value: '',
          },
        ],
        sortList: [
          {
            id: 'idAsc',
            field: 'id',
            label: 'Id ▲',
            asc: true,
          },
          {
            id: 'idDesc',
            field: 'id',
            label: 'Id ▼',
            asc: false,
          },
          {
            id: 'nameAsc',
            field: 'name',
            label: 'Name ▲',
            asc: true,
          },
          {
            id: 'nameDesc',
            field: 'name',
            label: 'Name ▼',
            asc: false,
          },
        ],
      },
    );
  }

  @projects.Action
  public ensureProjects!: () => void

  @projects.State
  public projects!: Array<GridRow>

  handleCloseAlert(): void {
    this.alert.isVisible = false;
  }

  mounted() {
    this.ensureProjects();

    if (this.$route.name === 'projects-success') {
      this.alert = {
        content: 'Form was successfully saved.',
        isVisible: true,
        type: 'success',
      };
    }
  }
}
</script>
